100 rem Get accurate mode 16 colour codes as RGB
102 rem SMSQ/E only
104 rem EXECute in mode 16 display
106 :
108 :
110 COLOUR_24
112 DIM nat%(255), rd%(255), gr%(255), bl%(255)
114 cnt% = -1
116 ch = FOPEN('con_300x10a0x0'): CLS#ch
118 base = SCR_BASE(#ch)
120 :
122 FOR r% = 0 TO 255
124 FOR g% = 0 TO 255
126 FOR b% = 0 TO 255
128  AT#ch; 0, 1: PRINT#ch; r%, g%, b%,
130  col = 65536 * r% + 256 * g% + b%
132  BLOCK#ch; 1, 1, 0, 0, col
134  n% = PEEK(base)
136  SELect ON cnt%
138   = -1: cnt% = 0: nat%(cnt%) = n%
140   = 0: IF n% <> nat%(0) THEN
142         cnt% = 1
144         IF n% < nat%(0) THEN
146          nat%(cnt%) = nat%(0): nat%(0) = n%
148         ELSE
150          nat%(cnt%) = n%
152         END IF
154        END IF
156    = REMAINDER
158      f% = BSearch%(n%, nat%(0 TO cnt%))
160      IF f% < 0 THEN
162       Insert ABS(f% + 1)
164       PRINT#ch; cnt%, n%,
166      END IF
168  END SELect
170 END FOR b%
172 END FOR g%
174 END FOR r%
176 sv
178 Outp
180 rep: beep 2000, 2: if inkey$(50) <> '': quit
182 :
184 :
186 DEFine PROCedure Outp
188 LOCal cf, p%, r%, t$(8)
190 t$ = FILL$(" ", 8)
192 cf = FOP_OVER("ram1_aur8_asm")
194 PRINT#cf; '* Aurora RGB palette'\\  t$; 'section colour'\\
196 PRINT#cf; t$; 'xdef aur8_tab'\\ '*'\ 'aur8_tab'
198 :
200 p% = 0
202 FOR r% = 0 TO 31
204  PRINT#cf; t$; 'dc.b ';
206  FOR c% = 0 TO 6
208   PRINT#cf; '$'; HEX$(rd%(p%), 8); ',$'; HEX$(gr%(p%), 8); ',$';  HEX$(bl%(p%), 8); ',';
210   p% = p% + 1
212  END FOR c%
214  PRINT#cf; '$'; HEX$(rd%(p%), 8); ',$'; HEX$(gr%(p%), 8); ',$';  HEX$(bl%(p%), 8)
216  p% = p% + 1
218 END FOR r%
220 :
222 PRINT#cf; \'*'\ t$; 'end'
224 CLOSE
226 END DEFine Outp
228 :
230 :
232 DEFine PROCedure sv
234 LOCal cf, i%
236 cf = FOP_OVER("ram1_aur_txt")
238 PRINT#cf; cnt%
240 FOR i% = 0 TO cnt%
242  PRINT#cf; nat%(i%), '$'; HEX$(rd%(i%), 8); HEX$(gr%(i%), 8); HEX$(bl%(i%), 8)
244 END FOR i%
246 CLOSE
248 END DEFine sv
250 :
252 :
254 rem + ------------------------------------------------------------------------ +
256 rem |<                                BSearch                                 >|
258 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
260 rem |                              Binary Search                               |
262 rem |                                                                          |
264 rem | Returns position if found, or -1 - position where item should go. Thus   |
266 rem | it can be used to add new, unique items to a list, in alphabetical order |
268 rem |                                                                          |
270 rem | Designed for numeric data but can be used for CASE-dependent strings     |
272 rem + ------------------------------------------------------------------------ +
274 rem | V0.01, pjw, 1996+, From TAOCP 6.2.1                                      |
276 rem | V0.02, pjw, 2021 Jun 30, Single comp and then SELect. Looks neater..     |
278 rem | V0.03, pjw, 2021 Jul 03, Not found returns -1-pos: arrays can start at 0 |
280 rem | V0.03, pjw, 2022 Jul 12, Numeric and CASE-dependent strings only         |
282 rem + ------------------------------------------------------------------------ +
284 :
286 DEFine FuNction BSearch%(item, Arr)
288 LOCal loop, u%, l%, i%
290 l% = 0: u% = DIMN(Arr)
292 REPeat loop
294  IF u% < l%: i% = -1 - l%: EXIT loop:           rem Not found here
296  i% = INT((l% + u%) / 2)
298  IF item = Arr(i%): EXIT loop
300  IF item < Arr(i%) THEN
302   u% = i% - 1
304  ELSE
306   l% = i% + 1
308  END IF
310 END REPeat loop
312 RETurn i%
314 END DEFine BSearch%
316 :
318 :
320 rem + ------------------------------------------------------------------------ +
322 rem |<                                 Insert                                 >|
324 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
326 rem |            Insert item in an array at given position, 0..DIMN            |
328 rem |                                                                          |
330 rem | Item and array can be of any type                                        |
332 rem |                                                                          |
334 rem | GLOBal cnt%                                                              |
336 rem + ------------------------------------------------------------------------ +
338 rem | V0.01, pjw, 2017 Mar                                                     |
340 rem | V0.02, pjw, 2021 Jun 30, Simplified                                      |
342 rem | V0.02, pjw, 2023 Apr 10, Specialised for purpose                         |
344 rem + ------------------------------------------------------------------------ +
346 :
348 DEFine PROCedure Insert(at%)
350 LOCal i%
352 cnt% = cnt% + 1
354 IF at% < cnt% THEN
356  FOR i% = cnt% TO at% + 1 STEP -1
358   nat%(i%) = nat%(i% - 1)
360   rd%(i%)  = rd%(i% - 1)
362   gr%(i%)  = gr%(i% - 1)
364   bl%(i%)  = bl%(i% - 1)
366  END FOR i%
368 END IF
370 nat%(at%) = n%
372 rd%(at%)  = r%
374 gr%(at%)  = g%
376 bl%(at%)  = b%
378 END DEFine Insert
380 :
382 :
